---
title: "About me"
---

Hi all! I am Davide Polonio, a programmer and devOps engineer. I am born in 1994
and started messing with computers since I was 8 (my first OS was the only and
glorious Windows 95), and from there I continued my path to learn about
computers and how to ~~break~~ tweak them. I graduated at university of Padova
with a master degree in computer science in 2018.

I prefer back-end stuff (I usually end up using Java, Golang, Rust and Bash to
gluing stuff around), especially automating releases with Continuous Integration
and Continuous Delivery. I create and manage pipelines for Jenkins (and I
currently administer Jenkins as well), but I also know other CI systems like
Github Actions, Travis CI, Drone CI (or the now clone Woodpecker). I enjoy
container technologies, starting from Docker, Podman and going on to
orchestrators like Docker Swarm, Kubernetes and Nomad (which I would like to
learn more of the lasts two). If I can, I use Infrastructure as Code (IaC) tools
like Terraform and Packer to create and maintain infrastructure on cloud
providers, like AWS or Scaleway (I also maintain [Podman plugin for
Packer](https://github.com/Polpetta/packer-plugin-podman)). Automation is
usually my preferred way, since it helps developers focus only on the business
product instead of messing with tasks that can be done by a machine. Finally, I
am interested in development processes like (but not only) Agile, Scrum,
Waterfall. I think the right way to develop a product starts from how you
organize your workflow and what processes you put in place in order to keep the
_development machine_ going.

I am an open source enthusiast, so when I am able in my free time (or paid time
if it is an open source business project) I like to contribute to open source
projects and discover new ones. I believe in the added values that open source
software (and especially free software) can give respect to closed ones. My
dream job would be to contribute to one of the many open source I like full
time! 🤩

I'm not only into programming though! I like to practice sport. In particular, I
am a black belt Judo and I teach it at the local dojo were I live. I know how to
ski from when I was I child, and if possible I enjoy passing some time in the
middle of mountains to admire the beauty of nature in winter. Finally, I like to
play tabletops games and I enjoy things like table football, billiards, bowling
(although I suck at the last one 😅).

If you are interested in getting in touch with me (or to get my resume) you can
send me an e-mail (I prefer this way) at
[davide@poldebra.me](mailto:davide+bitdispenser@poldebra.me) or you can contact
me through my [LinkedIn](https://www.linkedin.com/in/davidepolonio/) profile.

## Why this website and this blog

As I have already written at the beginning of [my first blog post]({{< ref
"/hello-world.md" >}}) I liked the idea of a place where I can share my thoughts
regarding technologies, personal experiences and what not. This blog is open
source, and all my content is licensed under CC BY-SA 4.0. The repository can be
found either on [my personal Gitea
instance](https://git.poldebra.me/polpetta/bitdispenser.dev) or on [Github
(mirrored)](https://github.com/Polpetta/bitdispenser.dev).
